import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
import java.util.List;
import java.util.Collections;
import java.awt.Color; 

/**
 * Write a description of class Character here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Character extends Actor
{
    double speed = 0;
    double direction;
    double heading;
       
    public double doubleX;// = (double)getX();
    public double doubleY; // = (double)getY();
    
    // delta, change in position
    double dX;
    double dY;

    public void act() 
    {
        if ( speed < 0.0001 ) {
            speed = 0;
        }
        if ( speed == 0 ) {
            return;
        }

        doubleX += speed * dX;
        doubleY += speed * dY;

        setLocation((int)doubleX, (int)doubleY);
    }   
    
   protected void addedToWorld(World world) 
   {
        //startX = getX();
       //startY = getY();
       
       //super.setLocation(getX(), getY());

      doubleX = super.getX();
      doubleY = super.getY();
      
      
    }
    
    public void setContinuousLocation(double xIn, double yIn)
    {        
        doubleX = xIn;
        doubleY = yIn;
        
        super.setLocation(getX(), getY());
    }
    
    
    public int getX()
    {
        return (int)doubleX;
    }
    
    public int getY()
    {
        return (int)doubleY;
    }
    
   
    public double getXasDouble()
    {
        return doubleX;
    }
    
    public double getYasDouble()
    {
        return doubleY;
    }

    public boolean IsOutOfBounds()
    {     
        return false;
        //return ((LargeWorld)getWorld()).isOutOfBounds(getX(), getY());
//       return ((LargeWorld)getWorld()).isOutOfBounds((int)screenX, (int)screenY);
    }

    public double getHeading() {
        return heading;
    }

    public void setHeading(double newheading) {
        this. heading = newheading;
        setRotation((int)heading);
    }

    public double getDirection() {
        return direction;
    }

    public void setDirection(double newdirection) 
    {
        this.direction = newdirection;
        dX = Math.cos(Math.toRadians(direction));
        dY = Math.sin(Math.toRadians(direction));
    }

    public int getDeltaX()
    {
        return (int)(speed * dX);
    }
    
    public int getDeltaY()
    {
        return (int)(speed * dY);
    }
    
    /*
    public int getX() {
        int x = 0;
        try {
            x = super.getX();
        }
        catch (IllegalStateException e) 
        {
            int i = 0;
        }
        finally {}
        return x;
    }

    public int getY() {
        int y = 0;
        try {
            y = super.getY();
        }
        catch (IllegalStateException e) 
        {
            int i = 0;
        }
        finally {}
        return y;
    }
    */
   
    public ArrayList<CharacterListItem> getOrderedCharactersInRange(int distance, java.lang.Class cls)
    {
        List closeObjects = getObjectsInRange( distance, cls );

        ArrayList<CharacterListItem> orderedList = new ArrayList<CharacterListItem>();

        for(int i = 0; i < closeObjects.size(); i++ )
            orderedList.add(new CharacterListItem((Character)closeObjects.get(i), getDistance((Actor)closeObjects.get(i))));

        Collections.sort(orderedList);

        return orderedList;
    }

    /**
     * Returns a positive value indicating the euclidean distance between and other
     */
    public double getDistance(Actor other) 
    { 
        int x = Math.abs(other.getX()-getX()); 
        int y = Math.abs(other.getY()-getY()); 
        double distance = Math.sqrt((x*x)+(y*y)); 
        return distance; 
    } 
    
    public double convertAngleToInput(double angle)
    {
        if(angle < 0)
            angle = 360 - (angle%360);
        else
            angle = angle%360;

        if(angle > 180)
            angle = 0 - (360 - angle);

        else if(angle < -180)
            angle = 360 + angle;

        return angle/180;
    }

    // returns a value between -1 and 1 describing the position of a relative object to the 
    // rotation of this object
    public double getRelativePosition(Character relative)
    {        
        int deltaX = getX() - relative.getX(); 
        int deltaY = getY() - relative.getY();

        int myRotation = getRotation();
        double enemyAngleFromZero = 180 - Math.toDegrees(Math.atan2(-deltaY, deltaX));

        myRotation = (int)convertAngle(myRotation);
        enemyAngleFromZero = (int)convertAngle(enemyAngleFromZero);

        double angleBetween = (angleDifference(myRotation, (int)enemyAngleFromZero)); 
        angleBetween = 1-(int)convertAngle(angleBetween);

        return angleBetween/(double)180.0;
    }
    
    public double getRelativePositionAngle(Character relative)
    {        
        int deltaX = getX() - relative.getX(); 
        int deltaY = getY() - relative.getY();

        int myRotation = getRotation();
        double enemyAngleFromZero = 180 - Math.toDegrees(Math.atan2(-deltaY, deltaX));

        myRotation = (int)convertAngle(myRotation);
        enemyAngleFromZero = (int)convertAngle(enemyAngleFromZero);
        
        return enemyAngleFromZero;
    }

    public double angleDifference(int angle1, int angle2)
    {
        return (angle1 + 180 -  angle2) % 360 - 180;
    }
    
    public double convertAngle(double ang)
    {
        if(ang > 180)
            return ang - 360;
        else if(ang < -180)
            return ang + 360;
        return ang;
    }
}
