import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.*;

import java.awt.Font;

/**
 * Write a description of class LargeWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class LargeWorld extends World
{
    
    static int GAME_LENGTH = 8000;
    static double MAX_PERTURBATION = 0.15;
    static double MUTATION_RATE = 0.1;
    
    static int GENS_BETWEEN_RESET = 10;
  
    static Random myRandom = new Random();
     



    public static int generation = 0;
    public static int timePassed = 0;

  
 
    //  static NeuralNetwork[] population;
     
    
     private static GreenfootImage arena;// = new GreenfootImage("space_grid.jpg"); 

    public static final int WORLDHEIGHT = 2000;
    public static final int WORLDWIDTH  = 2000;

    public static final int SCREENHEIGHT = 600;
    public static final int SCREENWIDTH  = 600;

    public static double SCREENXOFFSET = 0;
    public static double SCREENYOFFSET = (int)(WORLDHEIGHT * 0.5 - SCREENHEIGHT * 0.5);
    
    final public static int RED_TEAM_SIZE = 50;
    final public static int BLUE_TEAM_SIZE = 50;

   HumanPlayer keyboardPlayer; 
    public GenericShip[] redTeam = new GenericShip[RED_TEAM_SIZE];
    public GenericShip[] blueTeam = new GenericShip[BLUE_TEAM_SIZE];
    
    public GenericShip[] ships; 
    
    Label blueCounter;
    Label redCounter;
    
    int wave = 0;
    
    // build the background image from a small tile
    static
    {    
        arena = new GreenfootImage(2000,2000); 
        
        Color myColor = new Color(100, 125, 250);
        
        for(int i = 0; i < 2000; i+=200)
        {
            for(int k = 0; k < 2000; k+=200)
            {                 
                 GreenfootImage grid = new GreenfootImage("space_grid.jpg");
                 
                 Font font = grid.getFont();    
                 font = font.deriveFont(48.0f);    
                 grid.setFont(font);    
                 grid.setColor(myColor); //Color.BLUE);    
                
                 String coord = "" + i/200;
                 
                 switch(k/200)
                 {
                     case 0 : coord += "A"; break;
                     case 1 : coord += "B"; break;
                     case 2 : coord += "C"; break;
                     case 3 : coord += "D"; break;
                     case 4 : coord += "E"; break;
                     case 5 : coord += "F"; break;
                     case 6 : coord += "G"; break;
                     case 7 : coord += "H"; break;
                     case 8 : coord += "I"; break;
                     case 9 : coord += "J"; break;
                     case 10 : coord += "K"; break;
                     
                     case 11 : coord += "L"; break;
                     case 12 : coord += "M"; break;
                     case 13 : coord += "N"; break;
                     case 14 : coord += "O"; break;
                     case 15 : coord += "P"; break;
                     case 16 : coord += "Q"; break;
                     case 17 : coord += "R"; break;
                     case 18 : coord += "S"; break;
                     case 19 : coord += "T"; break;
                     case 20 : coord += "U"; break;
                     
                     case 21 : coord += "V"; break;
                     case 22 : coord += "W"; break;
                     case 23 : coord += "X"; break;
                     case 24 : coord += "Y"; break;
                     case 25 : coord += "Z"; break;
                     
                     default : coord += "*"; break;
                 }
  
                 grid.drawString(coord, 10, 190);  
                 arena.drawImage(grid, i, k);
            }
        }
    }
    
 
    

    public LargeWorld()
    {    
        super(SCREENHEIGHT, SCREENWIDTH, 1, false);

        blueCounter = new Label(""+BLUE_TEAM_SIZE, Color.blue, Color.yellow);
        redCounter = new Label(""+RED_TEAM_SIZE, Color.red, Color.yellow);
        
        addObject(blueCounter, blueCounter.getImage().getWidth() + 10, blueCounter.getImage().getHeight() + 10);
        addObject(redCounter, SCREENWIDTH - redCounter.getImage().getWidth() - 10, redCounter.getImage().getHeight() + 10);

        prepare();
    }  
    
    public void setUpPlayer()
    {
        keyboardPlayer = new HumanPlayer();
        
        addObject(keyboardPlayer, this.getWidth()/2, this.getHeight()/2);
    }
    
    
    public void updateMap()
    {
        boolean xScroll = true;
        boolean yScroll = true;

        double dX = keyboardPlayer.getDeltaX();
        double dY = keyboardPlayer.getDeltaY();

        double aX = keyboardPlayer.getXasDouble();
        double aY = keyboardPlayer.getYasDouble();

        if((int)(SCREENXOFFSET + aX) + dX <= SCREENWIDTH/2 || (int)(SCREENXOFFSET + aX) + dX >= WORLDWIDTH - SCREENWIDTH/2)
            xScroll = false;

        if((int)(SCREENYOFFSET + aY) + dY <= SCREENHEIGHT/2 || (int)(SCREENYOFFSET + aY) + dY >= WORLDHEIGHT - SCREENHEIGHT/2)
            yScroll = false;

        if(xScroll)
        {
            SCREENXOFFSET += dX;
            List<Actor> shifted = getObjects(Character.class);

            for(Actor a : shifted)
            {
                if(a != keyboardPlayer)
                    ((Character)a).setContinuousLocation(((Character)a).getXasDouble() - dX, ((Character)a).getYasDouble());
            }
        }

        if(yScroll)
        {
            SCREENYOFFSET += dY;
            List<Actor> shifted = getObjects(Character.class);

            for(Actor a : shifted)
            {
                if(a != keyboardPlayer)
                    ((Character)a).setContinuousLocation(((Character)a).getXasDouble(), ((Character)a).getYasDouble() - dY);
            }
        }

        if(xScroll && yScroll)
            keyboardPlayer.setContinuousLocation(this.getWidth()/2, this.getHeight()/2);
        else if(xScroll)
            keyboardPlayer.setContinuousLocation(this.getWidth()/2, keyboardPlayer.getY());
        else if(yScroll)
            keyboardPlayer.setContinuousLocation(keyboardPlayer.getX(), this.getHeight()/2);

        drawCage();
    }
    
    public void purgeOutOfBounds()
    {
         List<Character> characters = getObjects(Character.class);
         
          for(Character character : characters)
          {
              if(isOutOfBounds(character.getX(), character.getY()))
              {
                  removeObject(character);
              }
          }
    }

    public boolean isOutOfBounds(int screenX, int screenY)
    {
        int leftBound = 0 - (int)SCREENXOFFSET;
        int rightBound = leftBound + WORLDWIDTH; //WORLDWIDTH - ((int)SCREENXOFFSET + SCREENWIDTH);

        int upperBound = 0 - (int)SCREENYOFFSET;
        int lowerBound = upperBound + WORLDHEIGHT; //WORLDHEIGHT - ((int)SCREENYOFFSET + SCREENHEIGHT);

        if(screenX > leftBound && screenX < rightBound && screenY > upperBound && screenY < lowerBound)
            return false;
        return true;
    }

    // networks trained on a 2000x2000 map. This interprets the co-ordinate system to something they understand
    public  int convertScreenXToMap(int xIn)
    {
        return xIn + (int)SCREENXOFFSET;
    }

    public int convertScreenYToMap(int yIn)
    {
        return (int)SCREENYOFFSET + yIn;
    }
    
    public static int convertMapXToScreenX(int xIn)
    {
        return xIn - (int)SCREENXOFFSET;
    }
    
    public static int convertMapYToScreenY(int yIn)
    {
        return yIn - (int)SCREENYOFFSET;
    }

    public void drawCage()  
    {  
        GreenfootImage background = getBackground();  

        getBackground().drawImage(arena, (int)-SCREENXOFFSET, (int)-SCREENYOFFSET);

        background.setColor(new Color(0, 255, 0));

        // Top
        int[] xs = {0 - (int)SCREENXOFFSET, 0 - (int)SCREENXOFFSET + WORLDWIDTH, 0 - (int)SCREENXOFFSET + WORLDWIDTH, 0 - (int)SCREENXOFFSET};
        int[] ys = {0 - (int)SCREENYOFFSET, 0 - (int)SCREENYOFFSET, 0 - (int)SCREENYOFFSET + 10, 0 - (int)SCREENYOFFSET + 10};
        background.fillPolygon(xs, ys, 4);

        // Bottom
        int[]  xs2 = {0 - (int)SCREENXOFFSET, 0 - (int)SCREENXOFFSET, 0 - (int)SCREENXOFFSET + WORLDWIDTH, 0 - (int)SCREENXOFFSET  + WORLDWIDTH };
        int[]  ys2 = {0 - (int)SCREENYOFFSET + WORLDHEIGHT, 0 - (int)SCREENYOFFSET + WORLDHEIGHT - 10, 0 - (int)SCREENYOFFSET + WORLDHEIGHT - 10, 0 - (int)SCREENYOFFSET + WORLDHEIGHT };
        background.fillPolygon(xs2, ys2, 4);

        // Right
        int[]  xs3 = {0 - (int)SCREENXOFFSET + WORLDWIDTH, 0 - (int)SCREENXOFFSET + WORLDWIDTH - 10, 0 - (int)SCREENXOFFSET + WORLDWIDTH - 10, 0 - (int)SCREENXOFFSET + WORLDWIDTH};
        int[]  ys3 = {0 - (int)SCREENYOFFSET, 0 - (int)SCREENYOFFSET     , 0 - (int)SCREENYOFFSET + WORLDHEIGHT, 0 - (int)SCREENYOFFSET + WORLDHEIGHT};
        background.fillPolygon(xs3, ys3, 4);

        // Left
        int[]  xs4 = {0 - (int)SCREENXOFFSET, 0 - (int)SCREENXOFFSET + 10, 0 - (int)SCREENXOFFSET + 10,         0 - (int)SCREENXOFFSET};
        int[]  ys4 = {0 - (int)SCREENYOFFSET, 0 - (int)SCREENYOFFSET     , 0 - (int)SCREENYOFFSET + WORLDHEIGHT, 0 - (int)SCREENYOFFSET + WORLDHEIGHT};
        background.fillPolygon(xs4, ys4, 4);

        List<GenericShip> ships = getObjects(GenericShip.class);
        List<GenericShip> blueTeamRemaining = new ArrayList<GenericShip>();
        List<GenericShip> redTeamRemaining = new ArrayList<GenericShip>();

        
        for(GenericShip ship : ships)
        {
            if(ship.blueTeam)
                blueTeamRemaining.add(ship);
            else 
                redTeamRemaining.add(ship);
        }
        
        background.setColor(Color.red); 

        for(Actor a : redTeamRemaining)
        {
            int keyboardX = keyboardPlayer.getX();
            int enemyX = a.getX();

            int keyboardY = keyboardPlayer.getY();
            int enemyY = a.getY();

            if(enemyY > 0 && enemyY < SCREENHEIGHT && enemyX > 0 && enemyX < SCREENWIDTH)
            {
                // player can already see the enemy, no need to add to radar
            }
            else
            {            
                double m;

                if((keyboardX - enemyX) != 0) 
                    m = (keyboardY - enemyY) / (double)(keyboardX - enemyX);
                else
                    m = 0;

                double b = keyboardY - (m * keyboardX);

                double xPoint;
                if(enemyX >= keyboardX)
                    xPoint = SCREENWIDTH - 10;
                else
                    xPoint = 0 + 10;

                double yPoint = m * xPoint + b;

                if(yPoint > SCREENHEIGHT)
                {
                    yPoint = SCREENHEIGHT - 10 ;
                    xPoint = (yPoint - b) / m;
                }
                else if(yPoint < 0)
                {
                    yPoint = 0 + 10 ;
                    xPoint = (yPoint - b) / m;
                }

                background.fillOval((int)xPoint, (int)yPoint, 5, 5); 
            }
        }
        
        background.setColor(Color.blue); 

        for(Actor a : blueTeamRemaining)
        {
            int keyboardX = keyboardPlayer.getX();
            int enemyX = a.getX();

            int keyboardY = keyboardPlayer.getY();
            int enemyY = a.getY();

            if(enemyY > 0 && enemyY < SCREENHEIGHT && enemyX > 0 && enemyX < SCREENWIDTH)
            {
                // player can already see the friendly, no need to add to radar
            }
            else
            {            
                double m;

                if((keyboardX - enemyX) != 0) 
                    m = (keyboardY - enemyY) / (double)(keyboardX - enemyX);
                else
                    m = 0;

                double b = keyboardY - (m * keyboardX);

                double xPoint;
                if(enemyX >= keyboardX)
                    xPoint = SCREENWIDTH - 10;
                else
                    xPoint = 0 + 10;

                double yPoint = m * xPoint + b;

                if(yPoint > SCREENHEIGHT)
                {
                    yPoint = SCREENHEIGHT - 10 ;
                    xPoint = (yPoint - b) / m;
                }
                else if(yPoint < 0)
                {
                    yPoint = 0 + 10 ;
                    xPoint = (yPoint - b) / m;
                }

                background.fillOval((int)xPoint, (int)yPoint, 5, 5); 
            }
        }
    } 

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        setUpPlayer();
        
        setUpWaves(BLUE_TEAM_SIZE, RED_TEAM_SIZE);
        
        updateMap();
    }
   
   
   
    public void setUpWaves(int friendlies, int enemies)
    {
        if(generation%GENS_BETWEEN_RESET == 0)
        {
            ships = new GenericShip[friendlies + enemies];
            
            for(int i = 0; i < (friendlies + enemies); i++)
            {
                int border = 30;
                int startX; // = myRandom.nextInt(WORLDWIDTH - (2 * border)) + border; 
                int startY = WORLDHEIGHT - (myRandom.nextInt(WORLDHEIGHT - (2 * border)) + border);
                
                int rotation;
                
            
                if(i < friendlies)
                 {
                     ships[i] = new GenericShip(true);
                     
                     startX = 20 + myRandom.nextInt(250);
                     rotation = 0;
                 }
                 else
                 {
                     ships[i] = new GenericShip(false);
                     startX = WORLDWIDTH - 20 - myRandom.nextInt(250);
                     
                     rotation = 180;
                 }
                 
                 if(i != 0)
                 {
                     // make each brain slightly different
                    ships[i].excelBrain.mutate(MUTATION_RATE, MAX_PERTURBATION);
                }
                
                 startX = convertMapXToScreenX(startX);
                 startY = convertMapYToScreenY(startY);

                 addObject(ships[i], startX, startY);


                 ships[i].turn(rotation);
            }
        }
    }
    
   
    public void act()
    {
        purgeOutOfBounds();
        
        List<GenericShip> shipList = getObjects(GenericShip.class);
        
        int blueCount = 0;
        int redCount = 0;
        
        for(GenericShip ship : shipList)
        {
            if(ship.blueTeam)
            {
                blueCount++;
            }
            else
            {
                redCount++;
            }
        }
                
        blueCounter.setText("" + blueCount);
        redCounter.setText("" + redCount );
   
        if(getObjects(HumanPlayer.class).size() == 0)
        {
            Label loser = new Label("Loser", Color.red, Color.yellow);
            addObject(loser, SCREENWIDTH/2, SCREENHEIGHT/2);
            
            Greenfoot.stop();
        }
        else if(redCount <= 0)
        {
            Label winner = new Label("WINNER!", Color.blue, Color.yellow);
            addObject(winner, SCREENWIDTH/2, SCREENHEIGHT/2);
            
            Greenfoot.stop();
        }
        else
        {
            updateMap();
        }
    }        
}
