/**
 * Write a description of class NeuralNetwork here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */

import java.util.StringTokenizer;

public class NeuralNetwork  implements Comparable<NeuralNetwork>
{    
    double performance = 0;
    
    ProcessingElement[] hiddenLayer;
    ProcessingElement[] outputLayer;

    public NeuralNetwork(int inputs, int outputs, int hiddenLayerNeurons)
    {
        hiddenLayer = new ProcessingElement[hiddenLayerNeurons];
        outputLayer = new ProcessingElement[outputs];
        
        for(int i = 0; i < hiddenLayerNeurons; i++)
            hiddenLayer[i] = new ProcessingElement(inputs);
            
        for(int i = 0; i < outputs; i++)
            outputLayer[i] = new ProcessingElement(hiddenLayerNeurons);  
    }
    
    public NeuralNetwork(String genotype)
    {
        StringTokenizer St = new StringTokenizer(genotype,",");
        
        int inputs = Integer.parseInt(St.nextToken());
        int outputs  = Integer.parseInt(St.nextToken());
        int hiddenLayerNeurons = Integer.parseInt(St.nextToken());
        
        hiddenLayer = new ProcessingElement[hiddenLayerNeurons];
        outputLayer = new ProcessingElement[outputs];
        
        for(int i = 0; i < hiddenLayer.length; i++)
        {
            double[] weights = new double[inputs];
            
            for(int k = 0 ; k < inputs; k++)
            {
                weights[k] = Double.parseDouble(St.nextToken());
            }
            
            hiddenLayer[i] = new ProcessingElement(weights);
        }
        
        for(int i = 0; i < outputLayer.length; i++)
        {
            double[] weights = new double[hiddenLayer.length];
            
            for(int k = 0 ; k < hiddenLayer.length; k++)
            {
                weights[k] = Double.parseDouble(St.nextToken());
            }
            
            outputLayer[i] = new ProcessingElement(weights);
        }
    }
    
    public NeuralNetwork(NeuralNetwork neuralNetwork)
    {
        hiddenLayer = new ProcessingElement[neuralNetwork.hiddenLayer.length];
        outputLayer = new ProcessingElement[neuralNetwork.outputLayer.length];
        
        for(int i = 0; i < hiddenLayer.length; i++)
            hiddenLayer[i] = new ProcessingElement(neuralNetwork.hiddenLayer[i]);
            
        for(int i = 0; i < outputLayer.length; i++)
            outputLayer[i] = new ProcessingElement(neuralNetwork.outputLayer[i]); 
    }

 
    public double[] getOutput(double[] inputs)
    {
        double[] hiddenLayerOutputs = new double[hiddenLayer.length];
        
        for(int i = 0; i < hiddenLayer.length; i++)
            hiddenLayerOutputs[i] = hiddenLayer[i].getOutput(inputs);
        
        double[] outputs = new double[outputLayer.length];
        
        for(int i = 0; i < outputLayer.length; i++)
            outputs[i] = outputLayer[i].getOutput(hiddenLayerOutputs);

        return outputs;
    }
    
    public String getAsString()
    {
        String description = "" + hiddenLayer[0].getNumberInputs()  + ","
            + outputLayer.length + ","
            + hiddenLayer.length + ",";
        
        for(int i = 0; i < hiddenLayer.length; i++)
            description += hiddenLayer[i].getAsString();
        
        for(int i = 0; i < outputLayer.length; i++)
            description += outputLayer[i].getAsString();
            
        description += "#";
        
        return description;
    }
    
    public void mutate(double mutationRate, double maxPerturbation)
    {
        for(int i = 0; i < hiddenLayer.length; i++)
            hiddenLayer[i].mutate(mutationRate, maxPerturbation);
            
        for(int i = 0; i < outputLayer.length; i++)
            outputLayer[i].mutate(mutationRate, maxPerturbation);
    }
    
    public double getPerformance()
    {
        return performance;
    }
    
    public void setPerformance(double score)
    {
        performance = score;
    }
    
    public void updatePerformance(int delta)
    {
        performance += delta;
    }
    
    public void resetPerformance()
    {
        performance = 0;
    }
    
    //     @Override
   	public int compareTo(NeuralNetwork o) 
	{
		final int BEFORE = -1;
		final int EQUAL = 0;
		final int AFTER = 1;
		
		if(performance == o.performance) 
			return EQUAL;
		if(performance > o.performance) 
			return BEFORE;
		else 
			return AFTER;
	}
}
